package dsql;

import java.sql.*;
import java.util.Vector;

/** Wrapper around an SQL connection object to store its associated 
 * statements. */
public class ConnectStmt {
  Connection conn;
  Vector stmts = new Vector();

  public ConnectStmt(Connection _conn) {
    conn = _conn;
  }
  public Connection getConnection() {return conn;}
  public Vector getStatements() {return stmts;}
  public boolean hasStatements() {
    return !stmts.isEmpty();
  }

  public Statement addStatement() throws SQLException {
    return addStatement(getConnection().createStatement());
  }

  public Statement addStatement(int scroll,int concur) 
       throws SQLException {
    return addStatement(getConnection().createStatement(scroll,concur));
  }

  public Statement addStatement(Statement stmt) {
    stmts.addElement(stmt);
    return stmt;
  }

  public void removeStatement(Statement stmt) {
    stmts.remove(stmt);
  }
  public boolean hasStatement(Statement stmt) {
    return stmts.contains(stmt);
  }

  public boolean equals(Object obj) {
    if(!(obj instanceof ConnectStmt)) return false;
    ConnectStmt objcs = (ConnectStmt) obj;
    return getConnection()==objcs.getConnection() &&
      getStatements().equals(objcs.getStatements());
  }

  public int hashCode() {return conn.hashCode();}

}
