package dsql;

import dsql.value.*;

/** A variable, eg <code>$varx</code>. */
public class Variable extends DMExecuted {

  DSQL caller; // so that "trace" object is available...
  String name;
  Value value = null;

  public Variable(DSQL _caller, String _name) {
    caller = _caller;
    name = _name;
  }

  public Variable(DSQL _caller, String _name, Value _value) {
    caller = _caller;
    name = _name;
    value = _value;
  }

  public String getName() {
    return name;
  }

  public Value getValue() {
    return value;
  }

  public String toString() {
    return "$"+getName();
  }

  public void setValue(Value val) {
    value = val;
    caller.trace.trace(toString()+" set to "+value.toString());
  }

}
