package dsql;

import dsql.value.StringValue;
import dsql.exception.*;

import java.io.*;
import javax.swing.*;

/** Writes to a {@link dsql.Variable Variable}. */

public class VariableOutputStream extends OutputStream {

  Variable var;

  public VariableOutputStream(Variable _var) throws ExecuteException {
    var = _var;
    var.setValue(new StringValue(var.caller));
  }

  public void write(byte[] b) {
    append(new String(b));
  }

  public void write(byte[] b, int off, int len) {
    append(new String(b,off,len));
  }

  // let's hope the caller won't use this method because it would
  // be very inefficient!
  public void write(int b) {
    char[] bs = new char[1];
    bs[0] = (char) b;
    append(new String(bs));
  }

  protected void append(String str) {
    if(!(var.getValue() instanceof StringValue))
	// somebody tampered with the variable! we could throw an IOException
	// but we just silently reset the string
      var.setValue(new StringValue(var.caller));
    ((StringValue)var.getValue()).append(str);
  }

}
