package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

import java.io.*;

/** An assignment statement, e.g. $varx = <sql>...</sql> */
public class ASTAssignment extends DMNode {

  /** Constructor for the parser */
  public ASTAssignment(int id) {
    super(id);
  }

  /** Constructor for the parser */
  public ASTAssignment(Parser p, int id) {
    super(p, id);
  }

  public Value execute() throws ExecuteException {
    DMNode set = getArgument(0);
    if(!(set instanceof Assignable))
      throw new ExecuteException("Cannot assign a value to "+set);
    Value val = executeArgumentNonNull(1);
    ((Assignable)set).setValue(val);
    return val;
  }

}
