package dsql.parser;

import dsql.exception.*;
import dsql.value.*;

/** A binary operator, e.g. equals */
public abstract class ASTBinaryOperator extends DMNode {

  public ASTBinaryOperator(int id) {
    super(id);
  }

  public ASTBinaryOperator(Parser p, int id) {
    super(p, id);
  }

  /** operators priority: * /, + - ||, = lt gt, AND OR */
  protected int priority() {
    return Integer.MAX_VALUE;
  }

  public String getString() {
    String r = "";
    if(jjtGetNumChildren()>=1)
      r = r+((DMNode)children[0]).getString();
    r = r+toString();
    if(jjtGetNumChildren()>=2)
      r = r+((DMNode)children[1]).getString();
    return r;
  }
}
