package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

/** A concat expression, e.g. 'Hell' || 'o!' */
public class ASTConcat extends ASTBinaryOperator {

  /** Constructor for Parser */
  public ASTConcat(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTConcat(Parser p, int id) {
    super(p, id);
  }

  protected int priority() {return 20;}

  public Value execute() throws ExecuteException {
    Value first = executeArgumentNonNull(0);
    Value second = executeArgumentNonNull(1);
    return new StringValue(caller,first.getString()+second.getString());
  }
}
