package dsql.parser;

import dsql.exception.*;
import dsql.value.*;

/** A &lt;DBMS&gt; element */
public class ASTDBMS extends ASTDocContext {

  /** Constructor for Parser */
  public ASTDBMS(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTDBMS(Parser p, int id) {
    super(p, id);
  }

  /** Constructor for ASTXMLElement.recast() */
  public ASTDBMS(ASTXMLElement toCopy) {
    super(toCopy);
  }

  public String toString() {
    return "<dbms id=\""+getId()+"\">";
  }

  public ASTDriver[] getDrivers() {
    return (ASTDriver[]) getElements(ASTDriver.class);
  }

  public ASTDriver getDriver(String driverid) throws ExecuteException {
    for(int i=0; i<children.length; i++) 
      if((children[i] instanceof ASTDriver) &&
         ((ASTDriver)children[i]).getId().equals(driverid))
        return (ASTDriver)children[i];
    throw new ExecuteException("no <driver> with id=\""+driverid+"\" is "+
      "defined in <dbms id=\""+getId()+"\">");
  }

  public String getId() {
    return getAttributeValue("id");
  }

  public Value execute() throws ExecuteException {
    ASTDBMS res = (ASTDBMS) executeXML();
    if(res.getId()==null) throw new ExecuteException(
      "Element <dbms> does not have id attribute");
    res.getDoc().addDBMS(this);
    return new XmlDataValue(res);
  }


}
