package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

public class ASTDiff extends ASTSetOperator {

  static int NEW = 1;
  static int DEL = 2;
  static int UPD = 4;

  int mode = NEW | UPD;

  public ASTDiff(int id) {
    super(id);
  }

  public ASTDiff(Parser p, int id) {
    super(p, id);
  }

  public void setMode(int _mode) {mode=_mode;}

  public Value execute() throws ExecuteException {
    TableResult  t1 = executeArgumentTable(0), t2 = executeArgumentTable(1);
    ConstructedTableHash tnew = new ConstructedTableHash(t1);
    ConstructedTableHash t1h = null, t2h = null;
    // prepare hash tables
    if((mode&NEW)!=0 || (mode&UPD)!=0) {
      if(t1 instanceof ConstructedTableHash) t1h = (ConstructedTableHash) t1; 
      else t1h = createNewTableHash(t1,t2);
      t1 = t1h;
    }
    if((mode&DEL)!=0) {
      if(t2 instanceof ConstructedTableHash) t2h = (ConstructedTableHash) t2; 
      else t2h = createNewTableHash(t2,t1);
      t2 = t2h;
    }
    // NEW and UPD
    if((mode&NEW)!=0 || (mode&UPD)!=0) {
      t2.reset();
      while(t2.nextRecord()) {
        RecordHash rechash = t1h.getNewRecordHash(t2.readCurrentRecord());
        if(!t1h.exists(rechash)) {if((mode&NEW)!=0) tnew.addRecord(rechash);}
        else {
          if(!t1h.existsAllFields(rechash) && ((mode&UPD)!=0)) 
            tnew.addRecord(rechash);      
        }
      }
    }
    // DEL
    if((mode&DEL)!=0) {
      t1.reset();
      while(t1.nextRecord()) {
        RecordHash rechash = t2h.getNewRecordHash(t1.readCurrentRecord());
        if(!t2h.exists(rechash)) {tnew.addRecord(rechash);}
      }
    }
    return tnew;
  }


}
