package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

/** A &lt;driver&gt; element (inside &lt;dbms&gt; elements) */
public class ASTDriver extends ASTXMLElement {

  /** Constructor for Parser */
  public ASTDriver(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTDriver(Parser p, int id) {
    super(p, id);
  }

  /** Constructor for ASTXMLElement.recast() */
  public ASTDriver(ASTXMLElement toCopy) {
    super(toCopy);
  }

  public String toString() {
    return "<driver id=\""+getId()+"\">";
  }

  public String getId() {
    String id = getAttributeValue("id");
    if(id==null) return "default"; else return id;
  }

  public String getJavaClass() {
    return getAttributeValue("javaclass");
  }

  public String getConnectionString(ASTConnect c) throws ExecuteException {
    ASTURL url = (ASTURL) getElement(ASTURL.class);
    if(url==null) throw new ExecuteException("no <url> element defined in "+
                                             toString());
    return url.getConnectionString(c);
  }

}
