package dsql.parser;

import dsql.*;
import dsql.exception.*;
import dsql.value.*;

import java.io.*;

/** A <dsql> element */
public abstract class ASTDsql extends ASTXMLElement {

  OutputStream out;

  /** Constructor for Parser */
  public ASTDsql(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTDsql(Parser p, int id) {
    super(p, id);
  }
 
  /** Constructor for ASTXMLElement.recast() */
  public ASTDsql(ASTXMLElement toCopy) {
    super(toCopy);
  }

  public OutputStream getOut() {return out;}
  public void setOut(OutputStream _out) {out=_out;}

  public String getXMLText() throws ExecuteException {
    return execute(true).getString();
  }

  public Value execute() throws ExecuteException {
    return execute(false);
  }

    // TBD: remove allowsExpr? (obsolete???)

  public Value execute(boolean allowsExpr) throws ExecuteException {
    String trace = getAttributeValue("trace");
    int previousTraceMode = caller.trace.getMode();
    if(trace!=null) {caller.trace.set(trace);}
    String outatt = getAttributeValue("out");
    if(outatt!=null) {
      if(outatt.startsWith("$")) {
        String varname = outatt.substring(1);
	getRoot().setVariable(varname,new StringValue(caller));
        setOut(new VariableOutputStream(getRoot().getVariable(varname)));
      } else
        try{setOut(new FileOutputStream(outatt));}
        catch (FileNotFoundException exc) {
          throw new ExecuteException("Unable to open "+outatt+" for writing");}
    }
    Value r = null;
    try {
      for(int i=0; i<jjtGetNumChildren(); i++) {
        Value t = ((DMNode)children[i]).executeWithCatch();
        if(t!=null)
	    r = t;
	    //          if(allowsExpr)
            //if(r==null) r = new StringValue(caller,t.getString());
            //else r.setString(r.getString()+t.getString());
	/*else
            throw new ExecuteException("Statement expected rather than "+
              "expression "+((DMNode)children[i]).getString(),
              (DMNode)children[i]);*/
      }
    } finally {
      if(trace!=null) getCaller().trace.setMode(previousTraceMode);
    }
    return r;
  }

}
