package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

/** An equal expression, e.g. $x = 'ha!' */
public class ASTEquals extends ASTBinaryOperator {

  /** Constructor for Parser */
  public ASTEquals(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTEquals(Parser p, int id) {
    super(p, id);
  }

  protected int priority() {return 40;}

  public Value execute() throws ExecuteException {
    Value first = executeArgumentNonNull(0);
    Value second = executeArgumentNonNull(1);
    if(first.equals(second))
      return BooleanValue.TRUE;
    else
      return BooleanValue.FALSE;
  }

  public String toString() {return "==";}

}
