package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

/** Multiplication operator */
public class ASTFloatDivOp extends ASTBinaryOperator {

  public ASTFloatDivOp(int id) {
    super(id);
  }

  public ASTFloatDivOp(Parser p, int id) {
    super(p, id);
  }

  protected int priority() {return 10;}

  public Value execute() throws ExecuteException {
    Value v1 = executeArgumentNonNull(0),
          v2 = executeArgumentNonNull(1);
    if(v1 instanceof IntValue && v2 instanceof IntValue) {
      int n1 = v1.getInt(), n2 = v2.getInt();
      if(n1 % n2 == 0)
	return new IntValue(caller,v1.getInt()/v2.getInt());
    }
    return new FloatValue(caller,v1.getFloat()/v2.getFloat());
  }

}
