package dsql.parser;

import dsql.exception.*;
import dsql.value.*;

import java.io.*;

/** A foreach statement, eg foreach $y in <sql>...</sql> print $y*/
public class ASTForEach extends DMNode {

  /** Constructor for the parser */
  public ASTForEach(int id) {
    super(id);
  }

  /** Constructor for the parser */
  public ASTForEach(Parser p, int id) {
    super(p, id);
  }

  public ASTVariable getVariable() throws ExecuteException {
    return (ASTVariable) getArgument(0);
  }

  public RecordHolder getTableValue() throws ExecuteException {
    return executeArgumentRecordHolder(1);
  }

  public DMNode getAction() throws ExecuteException {
    return (DMNode) getArgument(2);
  }

  public Value execute() throws ExecuteException {
    ASTVariable var = getVariable();
    RecordHolder tableValue = getTableValue();
    return loop(var, tableValue, getAction());
  }

  public Value loop(ASTVariable var, RecordHolder list, DMNode action)
      throws ExecuteException {
    List res = new List(getCaller());
    for(int i=1; i<=list.getRecordCount(); i++) {
      Value rec = list.getRecord(i);
      var.setValue(rec);
      res.getList().add(action.execute());
    }
    return res;
  }

}
