package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

/** Greater than (numeric), e.g. $x gt 42 or $x gte 42 */
public class ASTGtOp extends ASTBinaryOperator {

  boolean orequals = false;

  /** Constructor for Parser */
  public ASTGtOp(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTGtOp(Parser p, int id) {
    super(p, id);
  }

  public void setOrEquals() {orequals = true;}

  protected int priority() {return 40;}

  public Value execute() throws ExecuteException {
    float first = executeArgumentNonNull(0).getFloat();
    float second = executeArgumentNonNull(1).getFloat();
    if(first>second || (orequals && first==second))
      return BooleanValue.TRUE;
    else
      return BooleanValue.FALSE;
  }
}
