package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

/** An if statement */
public class ASTIf extends DMNode {

  /** Constructor for the parser */
  public ASTIf(int id) {
    super(id);
  }

  /** Constructor for the parser */
  public ASTIf(Parser p, int id) {
    super(p, id);
  }

  public Value execute() throws ExecuteException {
    Value cond = executeArgumentNonNull(0);
    boolean val = cond.getBoolean();
    caller.trace.debug("Value of conditional: "+val);
    if(val)
      return executeArgument(1);
    else
      if(hasArgument(2))
        return executeArgument(2);
      else
        return null;
  }

}
