package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

public class ASTInsert extends ASTTableUpdate {

  String[] labels;

  public ASTInsert(int id) {
    super(id);
  }

  public ASTInsert(Parser p, int id) {
    super(p, id);
  }

  public void setLabels(String[] _labels) {labels=_labels;}
  public String[] getLabels() {return labels;}

  /** in case labels are not set, construct some with size */
  public String[] getLabels(int size) {
    if(labels!=null) return labels;
    labels = new String[size];
    for(int i=0; i<labels.length; i++)
      labels[i] = "column "+(i+1);
    return labels;
  }

  public Value execute() throws ExecuteException {
    TableResult table = executeArgumentTable(0);
    Value toInsert = executeArgument(1);
    if(toInsert.isScalar() || jjtGetNumChildren()>2) {
      ConstructedTable newTable = new ConstructedTable(caller,
	getLabels(jjtGetNumChildren()-1));
      if((jjtGetNumChildren()-1)!=getLabels().length)
        throw new ExecuteException("Number of values does not match columns");
      String[] values = new String[getLabels().length];
      for(int i=2; i<jjtGetNumChildren(); i++)
	values[i-2] = executeArgument(i).getString();
      newTable.addRecord(values);
      table.insert(new RecordProxy(newTable,1));
    } else {
      if(toInsert instanceof TableResult) {
        ((TableResult)toInsert).gotoRecord(0); // before first record
        while(((TableResult)toInsert).nextRecord())
          table.insert((TableResult)toInsert);
      } else if(toInsert instanceof ColumnHolder)
       table.insert((ColumnHolder)toInsert);
    }
    return null;
  }

}
