package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

public class ASTInter extends ASTSetOperator {

  public ASTInter(int id) {
    super(id);
  }

  public ASTInter(Parser p, int id) {
    super(p, id);
  }

  public Value execute() throws ExecuteException {
    TableResult  t1 = executeArgumentTable(0), t2 = executeArgumentTable(1);
    ConstructedTableHash tref, tnew = new ConstructedTableHash(t1);
    if(t1 instanceof ConstructedTableHash) tref = (ConstructedTableHash) t1;
    else {tref = createNewTableHash(t1,t2);}
     t2.reset();
    while(t2.nextRecord()) {
	RecordHash rechash = tref.getNewRecordHash(t2.readCurrentRecord());
      if(tref.existsAllFields(rechash)) 
        if(!tnew.exists(rechash)) tnew.addRecord(rechash);
      // the second test is necessary to ensure no duplicates
      // are put in results
    }
    return tnew;
  }


}
