package dsql.parser;

import dsql.exception.*;
import dsql.value.*;

import java.io.*;

/** A left expression, e.g. left($x,1) */
public class ASTLeft extends ASTFunction {

  /** Constructor for Parser */
  public ASTLeft(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTLeft(Parser p, int id) {
    super(p, id);
  }

  public Value execute() throws ExecuteException {
    String str = executeArgumentNonNull(0).getString();
    int c = executeArgumentNonNull(1).getInt();
    if(c<1) throw new ExecuteException("Index "+c+" is out of range");
    if(c>str.length()) c = str.length();
    return new StringValue(caller,str.substring(0,c));
  }

}
