package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

/** Less than (numeric), e.g. $x lt 42 or $x lte 42 */
public class ASTLtOp extends ASTBinaryOperator {

  boolean orequals = false;

  /** Constructor for Parser */
  public ASTLtOp(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTLtOp(Parser p, int id) {
    super(p, id);
  }

  public void setOrEquals() {orequals = true;}

  protected int priority() {return 40;}

  public Value execute() throws ExecuteException {
    float first = executeArgumentNonNull(0).getFloat();
    float second = executeArgumentNonNull(1).getFloat();
    if(first<second || (orequals && first==second))
      return BooleanValue.TRUE;
    else
      return BooleanValue.FALSE;
  }
}
