package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

/** Addition operator */
public class ASTMinusOp extends ASTBinaryOperator {

  public ASTMinusOp(int id) {
    super(id);
  }

  public ASTMinusOp(Parser p, int id) {
    super(p, id);
  }

  protected int priority() {return 20;}

  public Value execute() throws ExecuteException {
    Value v1 = executeArgumentNonNull(0),
          v2 = executeArgumentNonNull(1);
    if(v1 instanceof IntValue && v2 instanceof IntValue)
      return new IntValue(caller,v1.getInt()-v2.getInt());
    else
      return new FloatValue(caller,v1.getFloat()-v2.getFloat());
  }

}
