package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

/** Multiplication operator */
public class ASTMultOp extends ASTBinaryOperator {

  public ASTMultOp(int id) {
    super(id);
  }

  public ASTMultOp(Parser p, int id) {
    super(p, id);
  }

  protected int priority() {return 10;}

  public Value execute() throws ExecuteException {
    Value v1 = executeArgumentNonNull(0),
          v2 = executeArgumentNonNull(1);
    if(v1 instanceof IntValue && v2 instanceof IntValue)
      return new IntValue(caller,v1.getInt()*v2.getInt());
    else
      return new FloatValue(caller,v1.getFloat()*v2.getFloat());
  }

}
