package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

/** A not equal expression, e.g. $x != 'ha!' */
public class ASTNotEquals extends ASTBinaryOperator {

  /** Constructor for Parser */
  public ASTNotEquals(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTNotEquals(Parser p, int id) {
    super(p, id);
  }

  protected int priority() {return 40;}

  public Value execute() throws ExecuteException {
    Value first = executeArgumentNonNull(0);
    Value second = executeArgumentNonNull(1);
    if(first.equals(second))
      return BooleanValue.FALSE;
    else
      return BooleanValue.TRUE;
  }

  public String toString() {return "!=";}

}
