package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

import java.io.*;

/** A quote expression */
public class ASTQuote extends ASTDsql {

  /** Constructor for Parser */
  public ASTQuote(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTQuote(Parser p, int id) {
    super(p, id);
  }

  /** Constructor for ASTXMLElement.recast() */
  public ASTQuote(ASTXMLElement toCopy) {
    super(toCopy);
  }

  public Value execute() throws ExecuteException {
    return execute(true);
  }

  public Value execute(boolean allowsExp) throws ExecuteException {
    String s = super.execute(true).getString(),
           quote = getQuote(), escQuote = getEscapeQuote(quote);
    return new StringValue(caller,quote+escape(s,quote,escQuote)+quote);
  }

  public String getQuote() throws ExecuteException {
    String quote = getAttributeValue("char");
    if(quote!=null) return quote;
    else return "'";
  }

  public String getEscapeQuote(String quoteChar) throws ExecuteException {
    String escQuote = getAttributeValue("escape");
    if(escQuote!=null) return escQuote;
    else return "''";
  }

  public String escape(String s, String quote, String escQuote) {
    return s.replaceAll(quote,escQuote);
  }

}
