package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

import java.io.*;

/** A right expression, e.g. right($x,1) */
public class ASTRight extends ASTFunction {

  /** Constructor for Parser */
  public ASTRight(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTRight(Parser p, int id) {
    super(p, id);
  }

  public Value execute() throws ExecuteException {
    String str = executeArgumentNonNull(0).getString();
    int c = executeArgumentNonNull(1).getInt();
    if(c<1) throw new ExecuteException("Index "+c+" is out of range");
    if(c>str.length()) c = str.length();
    caller.trace.debug("len:"+str.length()+" index:"+(str.length()-c));
    return new StringValue(caller,str.substring(str.length()-c));
  }

}
