package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

public class ASTSetMinus extends ASTSetOperator {

  public ASTSetMinus(int id) {
    super(id);
  }

  public ASTSetMinus(Parser p, int id) {
    super(p, id);
  }

  public Value execute() throws ExecuteException {
    TableResult t1 = executeArgumentTable(0), t2 = executeArgumentTable(1);
    ConstructedTableHash tref, tnew = new ConstructedTableHash(t1);
    if(t2 instanceof ConstructedTableHash) tref = (ConstructedTableHash) t2;
    else {tref = createNewTableHash(t2,t1);}
    t1.reset();
    while(t1.nextRecord()) {
      RecordHash rechash = tref.getNewRecordHash(t1.readCurrentRecord());
      if(!tref.existsAllFields(rechash)) tnew.addRecord(rechash);
    }
    return tnew;
  }


}
