package dsql.parser;

import dsql.Variable;
import dsql.exception.*;
import dsql.value.*;

import java.io.*;

/** A subroutine */
public class ASTSub extends DMNode {

  String name;

  /** Constructor for the parser */
  public ASTSub(int id) {
    super(id);
  }

  /** Constructor for the parser */
  public ASTSub(Parser p, int id) {
    super(p, id);
  }

  public void setName(String _name) {name=_name;}
  public String getName() {return name;}

  /** subroutine definition */
  public Value execute() throws ExecuteException {
    getRoot().addSub(this);
    return null;
  }

  /** subroutine execution */
  public Value executeCall(DMNode pars) throws ExecuteException {
    ASTDoc doc = getRoot();
    try {
      doc.pushVariableContext();
      int nbpardef = jjtGetNumChildren(),
          nbpar = pars.jjtGetNumChildren();
      for(int i=0; i<nbpardef-1; i++) {
        Value val;
        if(i<nbpar) val = pars.executeArgumentNonNull(i);
        else val = new StringValue(caller);
        doc.addVariable(new Variable(caller,
          ((ASTVariable)jjtGetChild(i)).getName(),val));
      }
      return executeArgument(nbpardef-1);
    } catch (ReturnException exc) {
      return exc.getValue();
    } finally {
      doc.popVariableContext();
    }
  }

}
