package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

import java.io.*;

/** A subroutine call */
public class ASTSubCall extends DMNode {

  String name;

  /** Constructor for the parser */
  public ASTSubCall(int id) {
    super(id);
  }

  /** Constructor for the parser */
  public ASTSubCall(Parser p, int id) {
    super(p, id);
  }

  public void setName(String _name) {name=_name;}
  public String getName() {return name;}

  public Value execute() throws ExecuteException {
    ASTSub sub = getRoot().getSub(getName());
    if(sub==null) throw new ExecuteException("Subroutine "+getName()+" is not defined");
    else return sub.executeCall(this);
  }

}
