package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

import java.io.*;

/** A substring expression, e.g. substring($x,0,1) */
public class ASTSubstring extends ASTFunction {

  /** Constructor for Parser */
  public ASTSubstring(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTSubstring(Parser p, int id) {
    super(p, id);
  }

  public Value execute() throws ExecuteException {
    String str = executeArgumentNonNull(0).getString();
    int start = executeArgumentNonNull(1).getInt();
    int nb = executeArgumentNonNull(2).getInt();
    if(start<1) throw new ExecuteException("Index "+start+" is out of range");
    if(nb<0) throw new ExecuteException("Index "+nb+" is out of range");
    if(start>str.length()) return new StringValue(caller,"");
    if((start+nb)>str.length()) nb = str.length()-start+1;
    return new StringValue(caller,str.substring(start-1,start-1+nb));
  }

}
