package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

import java.io.*;
import java.util.*;
import java.text.*;

/** Returns current date/time as a record */
public class ASTSysdate extends ASTFunction {

  protected static String[] DATELABELS = {"Text","Year","Month","Day",
    "DayOfWeek","Hour","Min","Sec","MilliSec","TimeZone","time"};

  /** Constructor for Parser */
  public ASTSysdate(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTSysdate(Parser p, int id) {
    super(p, id);
  }

  public Value execute() throws ExecuteException {
    Calendar cal = Calendar.getInstance();
    Date date = cal.getTime();
    ConstructedTable rs = new ConstructedTable(caller,DATELABELS);
    String[] rec = new String[11];
    SimpleDateFormat formatter = new SimpleDateFormat();
    if(hasArgument(0))
      formatter.applyPattern(executeArgumentNonNull(0).getString());
    rec[0] = formatter.format(date);
    rec[1] = String.valueOf(cal.get(Calendar.YEAR));
    rec[2] = String.valueOf(cal.get(Calendar.MONTH)+1);
    rec[3] = String.valueOf(cal.get(Calendar.DAY_OF_MONTH));
    rec[4] = String.valueOf(cal.get(Calendar.DAY_OF_WEEK));
    rec[5] = String.valueOf(cal.get(Calendar.HOUR));
    rec[6] = String.valueOf(cal.get(Calendar.MINUTE));
    rec[7] = String.valueOf(cal.get(Calendar.SECOND));
    rec[8] = String.valueOf(cal.get(Calendar.MILLISECOND));
    rec[9] = cal.getTimeZone().getDisplayName();
    rec[10] = String.valueOf(cal.getTimeInMillis());
    rs.addRecord(rec);
    rs.nextRecord();
    return rs;
  }

}
