package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

import java.sql.*;
import java.util.*;

/** A &lt;table&gt; element */
public class ASTTable extends ASTSQL {

  String  tableName = null; // only set after execute()

  /** Constructor for Parser */
  public ASTTable(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTTable(Parser p, int id) {
    super(p, id);
  }

  /** Constructor for ASTXMLElement.recast() */
  public ASTTable(ASTXMLElement toCopy) {
    super(toCopy);
  }

  public String[] getPrimaryKeys() throws ExecuteException {
    String keysAttr = getPrimaryKeysAttribute();
    if(keysAttr!=null)
      return getPrimaryKeysFromAttribute(keysAttr);
    else
      try {
        return connect.getPrimaryKeys(null,null,tableName);
      } catch (ExecuteException exc) {
        caller.trace.warning(exc.getMessage());
        return null;
      }
  }

  public String setTableName() throws ExecuteException {
    tableName = super.getXMLText().trim();
    if(tableName.equals("")) throw new ExecuteException(
      "No table name specified in <table> element");
    return tableName;
  }

  public String getExecuteString() throws ExecuteException {
    return "SELECT * FROM "+setTableName();
  }
}
