package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

/** A <url> element: appears in a <driver> element to specify 
 * how to build a connection string. */
public class ASTURL extends ASTXMLElement {

  public ASTURL(int id) {
    super(id);
  }

  public ASTURL(Parser p, int id) {
    super(p, id);
  }

  /** Constructor for ASTXMLElement.recast() */
  public ASTURL(ASTXMLElement toCopy) {
    super(toCopy);
  }

  public String toString() {
    return "<url>";
  }

  public String getConnectionString(ASTConnect c) throws ExecuteException {
    return getConnectionString(this,c);
  }

  protected String getConnectionString(ASTXMLElement e,ASTConnect c) 
      throws ExecuteException {
    String r = "";
    for(int i=0; i<e.jjtGetNumChildren(); i++) {
      if(e.children[i] instanceof ASTXMLText)
        r = r + ((ASTXMLElement)e.children[i]).getXMLText().trim();
      else if(e.children[i] instanceof ASTOptional) {
        try {
          r = r + getConnectionString((ASTXMLElement)e.children[i],c);
        } catch (ExecuteException exc) {}
      } else if (e.children[i] instanceof ASTXMLElement) {
        String tagName = ((ASTXMLElement)e.children[i]).getTagName();
        ASTXMLElement cele = c.getElement(tagName);
        if(cele==null) throw new ConnectStringException(
          "Cannot build connection "+
          "string: element <"+tagName+"> is missing in <connect id=\""+
          c.getId()+"\">");
        r = r + cele.getXMLText();
      }
    }
    caller.trace.debug("Connection string: "+r);
    return r;
  }

}
