package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

public class ASTUnion extends ASTSetOperator {

  boolean all = false; // return all results

  public ASTUnion(int id) {
    super(id);
  }

  public ASTUnion(Parser p, int id) {
    super(p, id);
  }

  public void setAll() {
    all = true;
  }

  public Value execute() throws ExecuteException {
    TableResult  t1 = executeArgumentTable(0), t2 = executeArgumentTable(1);
    if(all) {
      ConstructedTable tnew = createNewTable(t1);
      tnew.insert(t2);
      return tnew;
    } else {
      ConstructedTableHash tnew = createNewTableHash(t1,t2);
      insertNew(tnew,t2);
      return tnew;
    }
  }


}
