package dsql.parser;

import dsql.exception.*;
import dsql.value.*;

/** A variable expression, e.g. $varx. Note that this is not the
 * actual variable itself, which is stored in the document. */
public class ASTVariable extends DMNode implements Assignable {

  String name;
  ASTDoc doc;

  /** Constructor for the parser */
  public ASTVariable(int id) {
    super(id);
  }

  /** Constructor for the parser */
  public ASTVariable(Parser p, int id) {
    super(p, id);
  }

  public String getName() {return name;}
  public void setName(String _name) {
    name = _name;
  }
  public void setDocument(ASTDoc _doc) {
    doc = _doc;
  }

  public String toString() {return "$"+name;}

  public Value getValue() throws ExecuteException {
    return doc.getVariable(name).getValue();
  }

  public Value execute() throws ExecuteException {
    return getValue();
  }

  public void setValue(Value val) {
    doc.setVariable(name,val);
  }

}
