package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

import java.io.*;

/** An foreach statement, e.g. foreach $y in <sql>...</sql> print $y*/
public class ASTWhile extends DMNode {

  /** Constructor for the parser */
  public ASTWhile(int id) {
    super(id);
  }

  /** Constructor for the parser */
  public ASTWhile(Parser p, int id) {
    super(p, id);
  }

  public DMNode getCondition() {
    return (DMNode) children[0];
  }

  public DMNode getAction() {
    return (DMNode) children[1];
  }

  public Value execute() throws ExecuteException {
    DMNode cond = getCondition();
    DMNode body = getAction();
    while(cond.execute().getBoolean()) {
      body.execute();
    }
    return null;
  }

}
