package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

import java.util.*;

/** An XML entity */
public class ASTXMLEntity extends ASTXMLText {

  public String name;

  /** Constructor for Parser */
  public ASTXMLEntity(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTXMLEntity(Parser p, int id) {
    super(p, id);
  }

  public void set(String eName) throws TokenMgrError {
    name = eName;
    super.setString(getString(name));
  }

  public static String getString(String name) throws TokenMgrError {
    if(entities.containsKey(name))
      return entities.get(name).toString();
    else
      throw new TokenMgrError("Invalid entity "+name,-1);
  }

  // ********* PROTECTED *********

  protected static Hashtable entities = new Hashtable();

  static {
    entities.put("&apos;","'");
    entities.put("&quot;","\"");
    entities.put("&amp;","&");
    entities.put("&lt;","<");
    entities.put("&gt;",">");
  }

}
