package dsql.parser;

import dsql.exception.*;


import dsql.value.*;

/** XML text inside an XML element */
public class ASTXMLText extends ASTXMLElement {

  String str;

  /** Constructor for Parser */
  public ASTXMLText(int id) {
    super(id);
  }

  /** Constructor for Parser */
  public ASTXMLText(Parser p, int id) {
    super(p, id);
  }

  public ASTXMLText(String newStr) {
    super(-1);
    setString(newStr);
  }

  public void setString(String newStr) {str = newStr;}

  public String getXMLText() {return str;}
  public String toString() {return str;}
  public void print(ASTPrint printer) {printer.print(str);}

  public Value execute() {
    return new StringValue(getCaller(),str);
  }

  protected ASTXMLElement executeXML() {
    return this;
  }
}
