package dsql.parser;

import dsql.exception.*;


public class ParseExceptionDsql extends ParseException {

  public ParseExceptionDsql(Token currentTokenVal,
			    int[][] expectedTokenSequencesVal, String[] tokenImageVal) {
    super(currentTokenVal,expectedTokenSequencesVal,tokenImageVal);
  }

  public ParseExceptionDsql(ParseException exc) {
    this(exc.currentToken,exc.expectedTokenSequences,exc.tokenImage);
  }

  public String getMessage() {
    if (!specialConstructor) {
      return super.getMessage();
    }
    String expected = "";
    int maxSize = 0;
    boolean expectedBracket = false;
    for (int i = 0; i < expectedTokenSequences.length; i++) {
      if (maxSize < expectedTokenSequences[i].length) {
        maxSize = expectedTokenSequences[i].length;
      }
      for (int j = 0; j < expectedTokenSequences[i].length; j++) {
        if(j>0) expected += " ";
        String thisTokImage = tokenImage[expectedTokenSequences[i][j]];
        if(thisTokImage.equals("\")\"")) expectedBracket = true;
        expected += thisTokImage;
      }
    }
    String line = " at line " + currentToken.next.beginLine + ", column " + 
                  currentToken.next.beginColumn;
    if (expectedTokenSequences.length == 1) {
      return "Missing " + expected + line;
    } else {
      String invalid = "Invalid \"";
      Token tok = currentToken.next;
      for (int i = 0; i < maxSize; i++) {
	if (i != 0) invalid += " ";
	if (tok.kind == 0) {
	  invalid += tokenImage[0];
	  break;
	}
	invalid += add_escapes(tok.image);
	tok = tok.next; 
      }
      invalid += "\"" + line;
      if(expectedBracket) invalid += " (missing \")\"?)";
      return invalid;
    }
  }

}
