package dsql.parser;

import dsql.exception.*;

public class XMLAttribute {

  String name;

  /** This is set to an ASTStringExpr by the parser
   * and to a string when executed */
  Object value; 

  public XMLAttribute(String newName) {
    name = newName;
    value = null;
  }

  public XMLAttribute(String newName, ASTStringExpr newValue) {
    name = newName;
    value = newValue;
  }
    
  public String getName() {return name;}
  public String getValue() {
    if(value==null)
      return null;
    else
      return value.toString();
  }

  protected XMLAttribute executeXML() throws ExecuteException {
    if(value instanceof ASTDynamicString) 
      return new XMLAttribute(getName(),new ASTStaticString(
	((DMNode)value).executeWithCatch().getString()));
    else
      return this;
  }

  public boolean equals(Object attr) {
      if(!(attr instanceof XMLAttribute)) return false;
      XMLAttribute att = (XMLAttribute) attr;
      return getName().equals(att.getName()) &&
        (getValue()==null || att.getValue()==null ||
         getValue().equals(att.getValue()));
  }

  public String toString() {
    return name+"=\""+value+"\"";
  }

}
