package dsql.value;

import dsql.DSQL;
import dsql.exception.*;
import dsql.parser.ASTPrint;

import java.sql.*;

/** A "results" value, which may include several tables.
 * For example, the results of an SQL statement/query. */
public abstract class AbstractResults extends TableResult {

  public ConstructedResults getMeta() throws ExecuteException {
    return getMeta(false);
  }

  public void print(ASTPrint printer) throws ExecuteException {
    printer.printResults(this);
  }

  /** @param all if true, iterates through all results */
  public abstract ConstructedResults getMeta(boolean all) 
    throws ExecuteException;

  public abstract void addCurrentResultMeta(ConstructedResults r)
    throws ExecuteException;

  public abstract void allreset() throws ExecuteException;
  public abstract boolean hasResult();
  public abstract boolean nextResult() throws ExecuteException;

}
