package dsql.value;

import dsql.DSQL;
import dsql.exception.*;


/** A boolean return value */
public class BooleanValue extends StringValue {

  public BooleanValue(DSQL _caller, String newValue) {
    super(_caller,newValue.intern());
  }

  public BooleanValue(DSQL _caller, Boolean newValue) {
    this(_caller,newValue.booleanValue() ? "TRUE" : "FALSE");
  }

  public boolean getBoolean() {return this==TRUE;}
  public Object getObject() {return new Boolean(this==TRUE);}
  public Class getObjectClass() {return Boolean.TYPE;}

  public String getTypeName() {return "BOOLEAN";}

  public static final BooleanValue TRUE = new BooleanValue(null,"TRUE");
  public static final BooleanValue FALSE = new BooleanValue(null,"FALSE");

}
