package dsql.value;

import dsql.DSQL;
import dsql.exception.*;

/** A record where elements are "columns", ie can accessed by name,
 * or index */
public interface ColumnHolder {

  /** @param col column number (first column is 1)
   *  @return column value; usually a String, but can also be 
   *          a complex object, such as 
   *          {@link dsql.value.XmlDataValue XmlDataValue}.
   */
  public abstract Object getColumn(int col) throws ExecuteException;
  public abstract String getColumnString(int col) throws ExecuteException;

  /** @param name column name
   *  @return column value; usually a String, but can also be 
   *          a complex object, such as 
   *          {@link dsql.value.XmlDataValue XmlDataValue}.
   */
  public abstract Object getColumn(String name) throws ExecuteException;
  public abstract String getColumnString(String name) throws ExecuteException;

  public abstract int getColumnCount() throws ExecuteException;

  public abstract String getColumnLabel(int col) throws ExecuteException;

  public abstract int getColumnDisplaySize(int i) throws ExecuteException;

}
