package dsql.value;

import dsql.DSQL;


import dsql.exception.*;


import java.util.Hashtable;

public class ConstructedTableHash extends ConstructedTable {

  protected Hashtable hash = new Hashtable(); /** hash table of all records;
    * key is record, value is index in the records array */

  public ConstructedTableHash(DSQL _caller,String[] labels) {
    super(_caller,labels);
  }


  /** make a copy of source */
  public ConstructedTableHash(TableResult source) throws ExecuteException {
    super(source);
  }

  public RecordHash getNewRecordHash(String[] record) throws ExecuteException {
    return new RecordHash(record,getPrimaryKeys());
  }

  public void addRecord(String[] record) throws ExecuteException {
    addRecord(getNewRecordHash(record));
  }

  public void addRecord(RecordHash rechash) throws ExecuteException {
    if(!exists(rechash)) {
      super.addRecord(rechash.record);
      hash.put(rechash,new Integer(getRecordCount()));
    } else if(getPrimaryKeys()!=null)
        throw new ExecuteException("Inserting record "+rechash.getString()+
          " would violate primary key constraints");
  }

  /** @return true if the specified record is in this table.
   * If a primary key has been specified, will look only at the primary
   * key fields, i.e. this method might return true even if other fields
   * differ. To also check for non-primary fields (e.g. inter and minus 
   * operations) use existsAllFields */
  public boolean exists(RecordHash record) {
    return hash.containsKey(record);
  }

  public boolean existsAllFields(RecordHash record) throws ExecuteException {
    Integer iobj = (Integer) hash.get(record);
    if(iobj==null) return false;
    else {
      if(getPrimaryKeys()==null || getPrimaryKeys().length==0)
	return true;
      String[] rec = ((String[]) records.get(iobj.intValue()-1));
      return record.equalsAllFields(rec);
    }
  }
}
