package dsql.value;

import dsql.DSQL;
import dsql.exception.*;
import dsql.parser.ASTPrint;

/** A record holder that can iterate through its records */
public interface Cursor extends RecordHolder {

  public abstract void reset() throws ExecuteException;
  public abstract int currentRecord() throws ExecuteException;

  /** @param pos is the record position: 1 is the first record,
   * 0 is the record before first, -1 is after the last record */
  public abstract void gotoRecord(int pos) throws ExecuteException;

  public abstract boolean nextRecord() throws ExecuteException;

    /** get current record; this could be the actual record,
     * as does XmlRecordHolder, or a "proxy" as does
     * TableResult */
  public abstract Value getRecord() throws ExecuteException;

  public abstract void printRecord(ASTPrint printer) throws ExecuteException;

}
