package dsql.value;

import dsql.DSQL;


import dsql.exception.*;


/** A float return value */
public class FloatValue extends NumericValue {

  float value;

  public FloatValue(DSQL _caller,float newValue) {
    setCaller(_caller);
    value = newValue;
  }

  public FloatValue(DSQL _caller,Float newValue) {
    this(_caller,newValue.floatValue());
  }

  public FloatValue(String newValue) throws ExecuteException {
    try {value=Float.parseFloat(newValue);}
    catch (NumberFormatException exc) {
      throw new ExecuteException("Expression '"+newValue+"' is not a "+
                                 "valid float",exc);
    }
  }

  public String getString() {return String.valueOf(value);}
  public int getInt() throws ExecuteException {
    if((int)value==value) return (int) value;
    else throw new ExecuteException("Cannot convert "+value+
      " without loss of precision");
  }
  public float getFloat() {return value;}
  public boolean getBoolean() {return value!=0.0;}
  public String toString() {return getString();}
  public Object getObject() {return new Float(value);}
  public Class getObjectClass() {return Float.TYPE;}

  public String getTypeName() {return "FLOAT";}
  public String getSQLTypeName() {return "FLOAT";}

}
