package dsql.value;

import dsql.DSQL;


import dsql.exception.*;


/** An integer return value */
public class IntValue extends NumericValue {

  int value;

  public IntValue(DSQL _caller,int newValue) {
    setCaller(_caller);
    value = newValue;
  }

  public IntValue(DSQL _caller,Integer newValue) {
    this(_caller,newValue.intValue());
  }

  public IntValue(String newValue) throws ExecuteException {
    try {value=Integer.parseInt(newValue);}
    catch (NumberFormatException exc) {
      throw new ExecuteException("Expression '"+newValue+"' is not a "+
                                 "valid integer",exc);
    }
  }

  public String getString() {return String.valueOf(value);}
  public int getInt() {return value;}
  public float getFloat() {return (float) value;}
  public boolean getBoolean() {return value!=0;}
  public String toString() {return getString();}
  public Object getObject() {return new Integer(value);}
  public Class getObjectClass() {return Integer.TYPE;}

  public String getTypeName() {return "INTEGER";}
  public String getSQLTypeName() {return "INTEGER";}

}
