package dsql.value;

import dsql.DSQL;
import dsql.exception.*;
import dsql.parser.ASTPrint;

import java.util.*;

/** A holder for a Java object. The columns correspond to fields,
 * if they are available, or getX methods */
public class JavaObject extends NonScalarValue {

  protected Object obj;

  public JavaObject(DSQL _caller,Object _obj) {
    setCaller(_caller);
    obj = _obj;
  }

  public Object getObject() {return obj;}
  public Class getObjectClass() {return obj.getClass();}

  public void print(ASTPrint printer) throws ExecuteException {
    printer.print(getString());
  }

  public String getString() {
    return obj.toString();
  }

  public String toString() {
    return obj.toString();
  }

  static final String[] JAVALABELS = { "JavaClass" };

  public ConstructedResults getMeta() throws ExecuteException {
    ConstructedResults r = new ConstructedResults(getCaller());
    r.addTable(JAVALABELS);
    String[] colValues = new String[1];
    colValues[0] = obj.getClass().getName();
    r.addRecord(colValues);
    return r;
  }

  public boolean getBoolean() {return true;}

  public static JavaObject create(DSQL _caller,Object obj) {
    if(obj instanceof AbstractList)
      return new List(_caller,(AbstractList)obj);
    else
      return new JavaObject(_caller,obj);
  }

}
