package dsql.value;

import dsql.DSQL;
import dsql.exception.*;
import dsql.parser.ASTPrint;

import java.util.*;

/** A list */
public class List extends JavaObject implements RecordHolder {

  public List(DSQL _caller) {this(_caller,new ArrayList());}
    public List(DSQL _caller,int size) {this(_caller,new ArrayList(size));}
  public List(DSQL _caller,Object[] list) {
    this(_caller,new ArrayList(list.length));
    for(int i=0; i<list.length; i++) 
	((ArrayList)getObject()).add(list[i]);
  }
  public List(DSQL _caller,AbstractList obj) {
    super(_caller,obj);
  }

  public AbstractList getList() {return (ArrayList) getObject();}

  public boolean getBoolean() {
      return getList().size()!=0;
  }

  //******** RecordArray methods

  public int getRecordCount() {return getList().size();}

  public Value getRecord(int i) throws ExecuteException {
      checkRange(i);
      return Value.getValue(getCaller(),getList().get(i-1));
  }

  public void setRecord(int i, Value val) throws ExecuteException {
      checkRange(i);
      getList().set(i-1,val);
  }

  // ******************************

  protected void checkRange(int i) throws ExecuteException {
      if(i<1 || i>getList().size()) 
	  if(getList().size()==0)
	      throw new ExecuteException("List is empty");
          else
  	    throw new ExecuteException("Index "+i+" is out of range [1,"+
				      getList().size()+"]");
  }
}
