package dsql.value;

import dsql.DSQL;
import dsql.exception.*;
import dsql.parser.ASTPrint;

import java.sql.*;

/** A range results, e.g. 1..10 */
public class RangeValue extends NonScalarValue implements RecordHolder {

  public RangeValue(DSQL _caller,int _lower, int _upper) {
    setCaller(_caller);
    lower = _lower;
    upper = _upper;
    count = Math.abs(upper-lower)+1;
    if(lower<upper) direction = 1;
    else direction = -1;
  }

  public int lower, upper, direction, count;
    //  public int current = 0;

  public String getString() {
    return String.valueOf(lower);
  }
  public boolean getBoolean() {
    return count>0;
  }

    static final String[] RANGELABELS = { "From", "To" };

  public ConstructedResults getMeta() throws ExecuteException {
    ConstructedResults r = new ConstructedResults(getCaller());
    r.addTable(RANGELABELS);
    String[] colValues = new String[2];
    colValues[0] = ""+lower;
    colValues[1] = ""+upper;
    r.addRecord(colValues);
    return r;
  }

  public void print(ASTPrint printer) throws ExecuteException {
    for(int i=1; i<=count; i++)
	printer.println(""+(lower+(i-1)*direction));
  }

  // ************ RecordHolder methods

  public int getRecordCount() {
    return count;
  }
  public Value getRecord(int i) {
    if(i==-1) {i=upper+direction;}
    return new IntValue(getCaller(),lower+(i-1)*direction);
  }

  public void setRecord(int i, Value val) throws ExecuteException {
      throw new ExecuteException("Attempt to modify a range");
  }

}
