package dsql.value;

public class RecordHash {

  int hashCode;
  String[] record; // full record
  int[] primaryKeys;

  public RecordHash(String[] _record) {
    this(_record,null);
  }

  public RecordHash(String[] _record, int[] _primaryKeys) {
    record = _record;
    primaryKeys = _primaryKeys;
    hashCode = 1;
    if(primaryKeys!=null) {
      for(int i=0; i<primaryKeys.length; i++)
        hashCode = 31*hashCode+ (record[primaryKeys[i]-1]==null ? 0 
          : record[primaryKeys[i]-1].hashCode());
    } else
      for(int i=0; i<record.length; i++)
        hashCode = 31*hashCode+ (record[i]==null ? 0 : record[i].hashCode());
  }

  public int hashCode() {return hashCode;}
  public boolean equals(Object o) {
    if(o==null || !(o instanceof RecordHash)) return false;
    String[] record2 = ((RecordHash)o).record;
    if(record.length!=record2.length) return false;
    if(primaryKeys!=null) {
      for(int i=0; i<primaryKeys.length; i++)
        if(!(record[primaryKeys[i]-1]==null ? record2[primaryKeys[i]-1]==null :
          record[primaryKeys[i]-1].equals(record2[primaryKeys[i]-1]))) 
          return false;
    } else return equalsAllFields(record2);
    return true;
  }

  public boolean equalsAllFields(String[] record2) {
    for(int i=0; i<record.length; i++)
      if(!(record[i]==null ? record2[i]==null :
        record[i].equals(record2[i]))) return false;
    return true;
  }

  public String getString() {
    StringBuffer s = new StringBuffer();
    if(primaryKeys!=null) {
      for(int i=0; i<primaryKeys.length; i++) {
        if(i>0) s.append(",");
        s.append(record[primaryKeys[i]-1]);
        if(s.length()>80) return s.toString().substring(0,80)+"...";
      }
    } else {
      for(int i=0; i<record.length; i++) {
        if(i>0) s.append(",");
        s.append(record[i]);
        if(s.length()>80) return s.toString().substring(0,80)+"...";
      }
    }
    return s.toString();
  }

}
