package dsql.value;

import dsql.DSQL;
import dsql.exception.*;
import dsql.parser.ASTPrint;

/** A container for records, such as TableResult or XmlDataValue */

public interface RecordHolder {

  /** this function should be called with care as it can be computationaly
   * expensive for SQL Cursors!
   * @return number of records */
  public abstract int getRecordCount() throws ExecuteException;

  /** @return record at position i (first record is 1). For SQL cursors,
   * the returned Value can be a ProxyRecord */
  public abstract Value getRecord(int i) throws ExecuteException;

  public abstract void setRecord(int i,Value val) throws ExecuteException;
}
