package dsql.value;

import dsql.DSQL;
import dsql.exception.*;
import dsql.parser.ASTPrint;

public abstract class ScalarValue extends Value {

  public boolean equals(Object obj) {
    try {
      if(obj instanceof NumericValue)
	return obj.equals(this);
      else if(obj instanceof ScalarValue)
        return getString().equals(((ScalarValue)obj).getString());
      return false;
    } catch (ExecuteException exc) {return false;}
  }

  public boolean isScalar() {return true;}

  static final String[] SCALLABELS = { "SQLType", "NativeType" };

  public ConstructedResults getMeta() throws ExecuteException {
    ConstructedResults r = new ConstructedResults(getCaller());
    r.addTable(SCALLABELS);
    String[] colValues = new String[2];
    colValues[0] = getSQLTypeName();
    colValues[1] = getTypeName();
    r.addRecord(colValues);
    return r;
  }

  public void print(ASTPrint printer) throws ExecuteException {
    printer.print(getString());
  }

  /** @return the internal scalar type, e.g. "STRING" */
  public abstract String getTypeName();

  /** @return the corresponding SQL type, e.g. "VARCHAR" */
  public abstract String getSQLTypeName();

}

