package dsql.value;

import dsql.DSQL;
import dsql.exception.*;

/** A string return value */
public class StringValue extends ScalarValue {

  String val;

  public StringValue(DSQL _caller) {
    this(_caller,"");
  }

  public StringValue(DSQL _caller, String newValue) {
    setCaller(_caller);
    val = newValue;
  }

  public String getString() {return val;}
  public String toString() {return val;}
  public void setString(String _val) {val=_val;}

  public boolean getBoolean() {
    return val.length()>0 && !val.equals("0");
  }

  public String getTypeName() {return "STRING";}
  public String getSQLTypeName() {return "VARCHAR";}

  public void append(String str) {val = val+str;}

  public Object getObject() {return val;}
  public Class getObjectClass() {return val.getClass();}

}
