/** NAME: dsqlexe.c
 * AUTHOR: Francois Paradis
 * LANGUAGE: gcc
 * DESC: sample launcher for dsql
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main( int argc, char** argv )
{
  char* cmdline = (char*) malloc( 1024 ); /* big buffer */
  char* dsql_home = (char*) malloc( 1024 ); /* big buffer */
  char* old_dsql_home = getenv ( "DSQL_HOME" );
  strcpy(cmdline,"");

  if(!old_dsql_home)
    fprintf(stderr,"* please set DSQL_HOME\n");
  else {
    dsql_home = strcpy(dsql_home,old_dsql_home);
      // has to copy, otherwise changes are passed to child process!
    int len = strlen(dsql_home);
    if(len && isalpha(dsql_home[0]) && dsql_home[1]==':') {
      // convert DOS format to Cygwin
      strcat(cmdline,"/cygdrive/");
      dsql_home[1] = '\0';
      strcat(cmdline,dsql_home);
      strcat(cmdline,"/");
      if(len>1) {
        dsql_home++; dsql_home++;
        char* tok;
        while(tok = strtok(dsql_home," ")) {
          if(!dsql_home) strcat(cmdline,"\\ ");
	  char* tok2;
          // change backslash to slash
          while(tok2 = strchr(tok,'\\')) 
	    *tok2 = '/';
          strcat(cmdline,tok);
          dsql_home = NULL;
        }
      }
    } else
      // Unix/Linux format
      strcat(cmdline,dsql_home);
    // add trailing '/' if necessary
    int trail = strlen(cmdline);
    if(trail && cmdline[trail-1] != '/')
      strcat(cmdline,"/");
    strcat(cmdline,"bin/");
  }
  strcat(cmdline,"dsql");
  // add arguments
  int i, verbose=0;
  for(i=1; i<argc; i++) {
    if(!strcmp(argv[i],"-v")) verbose = 1;
    else {
      strcat(cmdline," \"");
      strcat(cmdline,argv[i]);
      strcat(cmdline,"\"");
    }
  }
  if(verbose) fprintf(stderr,"DSQL_HOME: %s\n",old_dsql_home);
  if(verbose) fprintf(stderr,"Command: %s\n",cmdline);
  if(verbose) fprintf(stderr,"DSQL_HOME: %s\n",dsql_home);
  system( cmdline );
  return 0;
}
